#import "CrackAttack.h"
#include "Attack.h"

const char * c_name, * c_host;
int c_mode, c_width, c_height, c_port;

@implementation CrackAttack

- (void)awakeFromNib
{
	[name setStringValue:NSUserName()];
	[preview setImage:[NSImage imageNamed:@"preview_normal.png"]];
}

- (IBAction)play:(id)sender
{
	c_name = [[name stringValue] cString];
	c_host = [[serveraddress stringValue] cString];
	
	if ([tab indexOfTabViewItem:[tab selectedTabViewItem]] == 0) c_mode |= CM_SOLO;
	if ([tab indexOfTabViewItem:[tab selectedTabViewItem]] == 1)
	{
		c_mode |= CM_SERVER;
		c_port = [port intValue];
	}
	if ([tab indexOfTabViewItem:[tab selectedTabViewItem]] == 2)
	{
		c_mode |= CM_CLIENT;
		c_port = [serverport intValue];
	}
	
	if ([quality indexOfSelectedItem] >= 1) c_mode |= CM_LOW_GRAPHICS;
	if ([quality indexOfSelectedItem] > 1) c_mode |= CM_REALLY_LOW_GRAPHICS;
		
	if ([mode indexOfSelectedItem] > 0) c_mode |= CM_X;
		
	if ([ai indexOfSelectedItem] > 0) c_mode |= CM_AI;
	if ([ai indexOfSelectedItem] == 2) c_mode |= CM_AI_EASY;
	if ([ai indexOfSelectedItem] == 3) c_mode |= CM_AI_MEDIUM;
	if ([ai indexOfSelectedItem] == 4) c_mode |= CM_AI_HARD;
	
	NSArray *res = [[resolution titleOfSelectedItem] componentsSeparatedByString:@"x"];
	c_width = [[res objectAtIndex:0] intValue];
	c_height = [[res objectAtIndex:1] intValue];
	
	[window close];

	setupLocalDataDirectory();
  
	run_crack_attack(c_mode, c_port, (char*) c_host, (char*) c_name, c_width, c_height);
}

- (IBAction)select:(id)sender
{
	int i = [sender indexOfSelectedItem];
	
	if (i == 0)
		[preview setImage:[NSImage imageNamed:@"preview_normal.png"]];
	else if (i == 1)
		[preview setImage:[NSImage imageNamed:@"preview_reduced.png"]];	
	else if (i == 2)
		[preview setImage:[NSImage imageNamed:@"preview_extremely_reduced.png"]];		
}
@end